☝️Small business or a startup? See if you qualify for our special offer.
+
List of all demos

JSON/CSV-based Angular Pivot Table

Jump straight into analyzing your JSON or CSV files with the Angular pivot grid.


    import { Component, OnInit, ViewChild } from "@angular/core";
    import { FlexmonsterPivot } from "ng-flexmonster";
    
    @Component({
      selector: "pivotComponent",
      templateUrl: "./pivot.component.html",
      styleUrls: ["./pivot.component.css"],
    })
    export class PivotComponent implements OnInit {
      @ViewChild("pivot") pivot!: FlexmonsterPivot;
    
      public report: Object = {
        dataSource: {
          type: "csv",
          filename: "https://cdn.flexmonster.com/data/happiness.csv",
          mapping: {
            "Year": {
              type: "string"
            }
          }
        },
        slice: {
          rows: [
            {
              uniqueName: "Region",
            },
            {
              uniqueName: "Country or region",
            },
          ],
          columns: [
            {
              uniqueName: "[Measures]",
            },
            {
              uniqueName: "Year",
            },
          ],
          measures: [
            {
              uniqueName: "Score",
              aggregation: "median",
              grandTotalCaption: "Average Happiness",
            },
          ],
        },
        conditions: [
          {
            formula: "AND(#value > 7.3, #value < 10)",
            format: {
              backgroundColor: "#f0c63e",
              color: "#000000",
              fontFamily: "Arial",
              fontSize: "12px",
            },
          },
          {
            formula: "AND(#value > 0, #value < 4.5)",
            format: {
              backgroundColor: "#f29c8d",
              color: "#000000",
              fontFamily: "Arial",
              fontSize: "12px",
            },
          },
        ],
        formats: [
          {
            name: "",
            decimalPlaces: 2,
          },
        ],
      };
    
      constructor() {}
    
      ngOnInit(): void {}
    
      onOpenLocalCSV() {
        this.pivot.flexmonster.connectTo({
          type: "csv",
          browseForFile: true,
        });
      }
    
      onLoadRemoteCSV() {
        let filename = prompt("Open remote CSV", "https://cdn.flexmonster.com/data/data.csv");
        if (filename != null) {
          this.pivot.flexmonster.connectTo({
            type: "csv",
            filename: filename,
          });
        }
      }
    
      onOpenLocalJSON() {
        this.pivot.flexmonster.connectTo({
          type: "json",
          browseForFile: true,
        });
      }
    
      onLoadRemoteJSON() {
        let filename = prompt("Open remote JSON", "https://cdn.flexmonster.com/data/data.json");
        if (filename != null) {
          this.pivot.flexmonster.connectTo({
            type: "json",
            filename: filename,
          });
        }
      }
    
      customizeCellFunction(cell: Flexmonster.CellBuilder, data: Flexmonster.CellData) {
        if (data.isGrandTotalColumn) {
          if ((data.value as number) < 5 && (data.value as number) >= 0) {
            cell.text = (data.value as number).toPrecision(3) + " ☹️";
          } else if ((data.value as number) >= 5 && (data.value as number) < 7) {
            cell.text = (data.value as number).toPrecision(3) + " 🙂";
          } else if ((data.value as number) >= 7 && (data.value as number) < 10) {
            cell.text = (data.value as number).toPrecision(3) + " 😃";
          }
        }
      }
    }
    
    <button (click)="onOpenLocalCSV()">Open local CSV</button>
    <button (click)="onLoadRemoteCSV()">Load remote CSV</button>
    <button (click)="onOpenLocalJSON()">Open local JSON</button>
    <button (click)="onLoadRemoteJSON()">Load remote JSON</button>
    
    <fm-pivot
      #pivot
      [componentFolder]="'https://cdn.flexmonster.com/'"
      [report]="report"
      [customizeCell]="customizeCellFunction">
    </fm-pivot>
    

    You can connect Flexmonster Pivot to your local, remote, or server-side generated JSON and CSV files and create a new data visualization with Angular in minutes.

    Use the mapping to clarify how your Angular reporting tool should interpret and display the fields from the file.

    We have made Flexmonster super flexible and optimized to work with a lot of data extremely fast on the client side. If your data files are more than 100 MB, we suggest using one of our data source solutions — Flexmonster Data Server. It's easy to configure this server-side tool for data aggregation, which will kick-start your web reporting with Angular.

☝️Small business or a startup? See if you qualify for our special offer.
+
List of all demos

JSON/CSV-based React Pivot Table

Create an interactive report based on the JSON or CSV data source.


    import React from "react";
    import * as FlexmonsterReact from "react-flexmonster";
    
    class PivotTableDemo extends React.Component {
      render() {
        return (
          <>
            <button onClick={this.onOpenLocalCSV}>Open local CSV</button>
            <button onClick={this.onLoadRemoteCSV}>Load remote CSV</button>
            <button onClick={this.onOpenLocalJSON}>Open local JSON</button>
            <button onClick={this.onLoadRemoteJSON}>Load remote JSON</button>
            <div className="App">
              <FlexmonsterReact.Pivot
                ref="pivot"
                componentFolder="https://cdn.flexmonster.com/"
                report={{
                  dataSource: {
                    type: "csv",
                    filename: "https://cdn.flexmonster.com/data/happiness.csv",
                    mapping: {
                      "Year": {
                        type: "string"
                      }
                    }
                  },
                  slice: {
                    rows: [
                      {
                        uniqueName: "Region",
                      },
                      {
                        uniqueName: "Country or region",
                      },
                    ],
                    columns: [
                      {
                        uniqueName: "[Measures]",
                      },
                      {
                        uniqueName: "Year",
                      },
                    ],
                    measures: [
                      {
                        uniqueName: "Score",
                        aggregation: "median",
                        grandTotalCaption: "Average Happiness",
                      },
                    ],
                  },
                  conditions: [
                    {
                      formula: "AND(#value > 7.3, #value < 10)",
                      format: {
                        backgroundColor: "#f0c63e",
                        color: "#000000",
                        fontFamily: "Arial",
                        fontSize: "12px",
                      },
                    },
                    {
                      formula: "AND(#value > 0, #value < 4.5)",
                      format: {
                        backgroundColor: "#f29c8d",
                        color: "#000000",
                        fontFamily: "Arial",
                        fontSize: "12px",
                      },
                    },
                  ],
                  formats: [
                    {
                      name: "",
                      decimalPlaces: 2,
                    },
                  ],
                }}
                customizeCell={this.customizeCellFunction}
              />
            </div>
          </>
        );
      }
    
      onOpenLocalCSV = () => {
        this.refs.pivot.flexmonster.connectTo({
          type: "csv",
          browseForFile: true,
        });
      };
    
      onLoadRemoteCSV = () => {
        let filename = prompt("Open remote CSV", "https://cdn.flexmonster.com/data/data.csv");
        if (filename != null) {
          this.refs.pivot.flexmonster.connectTo({
            type: "csv",
            filename: filename,
          });
        }
      };
    
      onOpenLocalJSON = () => {
        this.refs.pivot.flexmonster.connectTo({
          type: "json",
          browseForFile: true,
        });
      };
    
      onLoadRemoteJSON = () => {
        let filename = prompt("Open remote JSON", "https://cdn.flexmonster.com/data/data.json");
        if (filename != null) {
          this.refs.pivot.flexmonster.connectTo({
            type: "json",
            filename: filename,
          });
        }
      };
    
      customizeCellFunction = (cell, data) => {
        if (data.isGrandTotalColumn) {
          if (data.value < 5 && data.value >= 0) {
            cell.text = data.value.toPrecision(3) + " ☹️";
          } else if (data.value >= 5 && data.value < 7) {
            cell.text = data.value.toPrecision(3) + " 🙂";
          } else if (data.value >= 7 && data.value < 10) {
            cell.text = data.value.toPrecision(3) + " 😃";
          }
        }
      };
    }
    
    export default PivotTableDemo;
    

    Connect Flexmonster Pivot for React to your local, remote, or server-side generated JSON data. Once the data is loaded, you are ready to set up a new report on the React pivot table.

    You can also connect to local or remote static CSV files or CSV data generated by a server-side script. Once connected to CSV, create a new analytical report.

    Moreover, you can control how fields are displayed on the grid using the mapping. It also allows you to control how the reporting tool interprets the fields.

    Flexmonster is optimized to load and process your data extremely fast on the client side.

    But once the size of your data set reaches 100 MB or more, we recommend using Flexmonster Data Server. This server-side solution for data aggregation will boost your reporting. It takes a few minutes to set it up and jump-start reporting.

☝️Small business or a startup? See if you qualify for our special offer.
+
List of all demos

JSON/CSV-based Vue Pivot Table

Build an interactive report based on the JSON or CSV data source in your Vue project.


    <template>
      <button v-on:click="onOpenLocalCSV">Open local CSV</button>
      <button v-on:click="onLoadRemoteCSV">Load remote CSV</button>
      <button v-on:click="onOpenLocalJSON">Open local JSON</button>
      <button v-on:click="onLoadRemoteJSON">Load remote JSON</button>
    
      <Pivot
        ref="pivot"
        componentFolder="https://cdn.flexmonster.com/"
        v-bind:report="report"
        v-bind:customizeCell="customizeCell"
      />
    </template>
    
    <script>
    import Pivot from "vue-flexmonster/vue3";
    import "flexmonster/flexmonster.css";
    
    export default {
      name: "PivotComponent",
      components: {
        Pivot,
      },
      data() {
        return {
          report: {
            dataSource: {
              type: "csv",
              filename: "https://cdn.flexmonster.com/data/happiness.csv",
              mapping: {
                "Year": {
                  type: "string"
                }
              }
            },
            slice: {
              rows: [
                {
                  uniqueName: "Region",
                },
                {
                  uniqueName: "Country or region",
                },
              ],
              columns: [
                {
                  uniqueName: "[Measures]",
                },
                {
                  uniqueName: "Year",
                },
              ],
              measures: [
                {
                  uniqueName: "Score",
                  aggregation: "median",
                  grandTotalCaption: "Average Happiness",
                },
              ],
            },
            conditions: [
              {
                formula: "AND(#value > 7.3, #value < 10)",
                format: {
                  backgroundColor: "#f0c63e",
                  color: "#000000",
                  fontFamily: "Arial",
                  fontSize: "12px",
                },
              },
              {
                formula: "AND(#value > 0, #value < 4.5)",
                format: {
                  backgroundColor: "#f29c8d",
                  color: "#000000",
                  fontFamily: "Arial",
                  fontSize: "12px",
                },
              },
            ],
            formats: [
              {
                name: "",
                decimalPlaces: 2,
              },
            ],
          },
        };
      },
      methods: {
        onOpenLocalCSV() {
          this.$refs.pivot.flexmonster.connectTo({
            type: "csv",
            browseForFile: true,
          });
        },
        onLoadRemoteCSV() {
          const filename = prompt("Open remote CSV", "https://cdn.flexmonster.com/data/data.csv");
          if (filename != null) {
            this.$refs.pivot.flexmonster.connectTo({
              type: "csv",
              filename: filename,
            });
          }
        },
        onOpenLocalJSON() {
          this.$refs.pivot.flexmonster.connectTo({
            type: "json",
            browseForFile: true,
          });
        },
        onLoadRemoteJSON() {
          const filename = prompt("Open remote JSON", "https://cdn.flexmonster.com/data/data.json");
          if (filename != null) {
            this.$refs.pivot.flexmonster.connectTo({
              type: "json",
              filename: filename,
            });
          }
        },
        customizeCell(cell, data) {
          if (data.isGrandTotalColumn) {
            if (data.value < 5 && data.value >= 0) {
              cell.text = data.value.toPrecision(3) + " ☹️";
            } else if (data.value >= 5 && data.value < 7) {
              cell.text = data.value.toPrecision(3) + " 🙂";
            } else if (data.value >= 7 && data.value < 10) {
              cell.text = data.value.toPrecision(3) + " 😃";
            }
          }
        },
      },
    };
    </script>
    

    Load your local, remote, or server-side generated JSON or CSV files.

    Flexmonster Vue pivot grid is perfectly optimized to load and process your data extremely fast on the client side. But for large CSV or JSON files (more than 100 MB), we recommend using the Flexmonster Data Server tool, which is explicitly designed to handle large datasets.

    Use detailed guides:

    It will take just a few steps to set it up and start pivot table reporting in your Vue application.

    You can also use the mapping to control how the fields are shown on the grid in your Vue project.